"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.processWebPage = void 0;
var encodeagent_helper_util_1 = require("encodeagent-helper-util");
var encodeagent_helper_service_1 = require("encodeagent-helper-service");
var axios_1 = __importDefault(require("axios"));
var encodeagent_helper_ai_util_1 = require("encodeagent-helper-ai-util");
var encodeagent_helper_lambda_1 = require("encodeagent-helper-lambda");
var processWebPage = function (props) { return __awaiter(void 0, void 0, void 0, function () {
    var url, processContent, context, _a, logUsage, settings, useProxy, result, brightDataInfo, proxy, cost;
    var _b, _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                url = props.url, processContent = props.processContent, context = props.context;
                _a = (_b = props.settings) !== null && _b !== void 0 ? _b : {}, logUsage = _a.logUsage, settings = __rest(_a, ["logUsage"]);
                useProxy = (_c = props.useProxy) !== null && _c !== void 0 ? _c : true;
                if (!useProxy) return [3 /*break*/, 3];
                return [4 /*yield*/, (0, encodeagent_helper_service_1.getBrightDataInfo)("WEB")];
            case 1:
                brightDataInfo = _d.sent();
                if (!brightDataInfo) {
                    return [2 /*return*/, {
                            type: "error",
                            data: __assign(__assign({}, encodeagent_helper_service_1.HTTPERROR_400), { type: encodeagent_helper_service_1.ERROR_PARAMETER_MISSING, detail: { paramName: "BrightDataInfo" } })
                        }];
                }
                proxy = {
                    protocol: "http",
                    host: brightDataInfo.host,
                    port: brightDataInfo.port,
                    auth: {
                        username: brightDataInfo.user,
                        password: brightDataInfo.password
                    }
                };
                (0, encodeagent_helper_util_1.libTrackIsOn)() && console.log({ url: url, proxy: proxy });
                return [4 /*yield*/, axios_1.default.get(url, {
                        proxy: proxy
                    })];
            case 2:
                result = (_d.sent()).data;
                return [3 /*break*/, 5];
            case 3: return [4 /*yield*/, axios_1.default.get(url)];
            case 4:
                result = (_d.sent()).data;
                _d.label = 5;
            case 5:
                if (processContent) {
                    (0, encodeagent_helper_util_1.libTrackIsOn)() && console.log(result);
                    result = (0, encodeagent_helper_util_1.processWebPage)(url, result, settings !== null && settings !== void 0 ? settings : {});
                }
                if (!logUsage) return [3 /*break*/, 7];
                cost = (0, encodeagent_helper_ai_util_1.calculateAICost)({
                    modelId: "encode-web-processor",
                    defaultSurcharge: encodeagent_helper_util_1.SURCHARGE,
                    defaultCreditExchangeRate: encodeagent_helper_util_1.CREDIT_EXCHANGE_RATE,
                    inputTokens: 0,
                    outputTokens: 1,
                    additionalItems: []
                });
                return [4 /*yield*/, (0, encodeagent_helper_lambda_1.logUsage)({
                        id: (0, encodeagent_helper_util_1.newGuid)(),
                        name: "process-web-page",
                        context: context,
                        cost: cost,
                        aiKeyProvider: "solution"
                    })];
            case 6:
                _d.sent();
                _d.label = 7;
            case 7: return [2 /*return*/, { type: "success", data: result }];
        }
    });
}); };
exports.processWebPage = processWebPage;
//# sourceMappingURL=index.js.map